﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
#if B4A
'ignore DIP related warnings as they are not relevant when working with BitmapCreator.
#IgnoreWarnings: 6
#end if
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI 'ignore
	Public world As B2World

	Private ivForeground As B4XView
	Public ivBackground As B4XView
	Private PanelForTouch As B4XView
	Public lblStats As B4XView
	Public TileMap As X2TileMap
	Public Const ObjectLayer As String = "Object Layer 1"
	
	Public RightDown, LeftDown, Q As Boolean
	Private TankMovementForce As B2Vec2
	Private GameOver As Boolean

	Private Cart, WheelLeft, WheelRight, Pendulum,Pendulum2, ground, Mark As X2BodyWrapper
	
	Private HingeWheelLeft, HingeWheelRight, HingePendulum As B2RevoluteJoint
	
	Private WheelDriveMotor As B2MotorJoint
	
	Private PanelForTouch As B4XView
	Private MovingBody As Boolean
	Private TouchedBody As B2Body
	
	Private const DegToRAD As Double = 0.0174532925199432957
	Private const RADToDeg As Double = 57.295779513082320876

	Private angleController As PIDController
	Private positionController As PIDController

	Private targetPosition As Double
	Private posAvg As Double
	
	Public mScore As ScoreLabel
	Private ScoreLabel1 As ScoreLabel
	
	Private TouchPointVec As B2Vec2
	
	Private WheelRadius As Float
	
	Private const intProcessTyp As Int = 1  ' 0 = simple PID , 1 = advanced PID
	

End Sub

Public Sub Initialize (Parent As B4XView)
	
	Parent.LoadLayout("1")
	world.Initialize("world", world.CreateVec2(0, -10))
'	X2.Initialize(Me, ivForeground, world)

End Sub

Public Sub Start
	If X2.IsRunning Then Return
	X2.Initialize(Me, ivForeground, world)
	'
	'comment to disable debug drawing
	X2.EnableDebugDraw
	'
	X2.Reset
	
	GameOver = False
	Dim WorldHeight As Double = 20 '
	Dim WorldWidth As Double  = WorldHeight * 1.3333
	
	X2.ConfigureDimensions(world.CreateVec2(WorldWidth / 2, WorldHeight / 2),  WorldWidth)
	X2.PositionIterations = 30
	X2.VelocityIterations = 30
	
	lblStats.TextColor = xui.Color_Black
	lblStats.Color = 0x88ffffff
	lblStats.Font = xui.CreateDefaultBoldFont(20)
	
	mScore = ScoreLabel1
	TankMovementForce = X2.CreateVec2(0.025 * X2.TimeStepMs, 0)

	CreateStaticBackground
	TileMap.Initialize(X2, File.DirAssets, "thing.json", Null)
	TileMap.SetSingleTileDimensionsInMeters(WorldHeight / TileMap.TilesPerColumn, WorldHeight / TileMap.TilesPerColumn)
	TileMap.PrepareObjectsDef(ObjectLayer)
	

	Dim ol As X2ObjectsLayer = TileMap.Layers.Get(ObjectLayer)
	For Each template As X2TileObjectTemplate In ol.ObjectsById.Values
		If template.Name.Contains("Hinge") = False Then 
			Dim bw As X2BodyWrapper = TileMap.CreateObject(template)
			If bw.Name = "pendulumBody" Then
				Pendulum = bw
			else If bw.Name = "mark" Then
				Mark = bw
			else If bw.Name = "ground" Then
				ground = bw
			else If bw.Name = "leftWheelBody" Then
				WheelLeft = bw
				WheelRadius = WheelLeft.Body.FirstFixture.Shape.Radius
			End If

		End If
	Next
	
	CreateRevJointLeg
	'
	' Settings of Angel Controller
	angleController.Initialize( 19, .2, 8 )
	' Settings of Position Controller
'	positionController.Initialize( .91, 0.015,.013 )
	positionController.Initialize( 1., .05, 0.01 )
	'
	targetPosition =  Mark.Body.WorldCenter.X
	
	X2.Start
	
End Sub

Private Sub Game_Over(ft As X2FutureTask)
	X2.Stop
	Sleep(100)
	Start
End Sub

Private Sub CreateStaticBackground
	Dim bc As BitmapCreator
	bc.Initialize(ivBackground.Width / xui.Scale / 2, ivBackground.Height / xui.Scale / 2)
	bc.FillGradient(Array As Int(0xFF006EFF, 0xFF00DAAD), bc.TargetRect, "TOP_BOTTOM")
	X2.SetBitmapWithFitOrFill(ivBackground, bc.Bitmap)
End Sub


Private Sub CreateRevJointLeg
	
	Dim ol As X2ObjectsLayer = TileMap.Layers.Get(ObjectLayer)
	For Each template2 As X2TileObjectTemplate In ol.ObjectsById.Values
		Dim strName As String = template2.Name
		If strName.StartsWith("Hinge") Then 
			
			Dim template As X2TileObjectTemplate = TileMap.GetObjectTemplateByName(ObjectLayer,  template2.Name)
			Dim revdef As B2RevoluteJointDef
			
			'split the string (and remove spaces near the commas)
			'
			Dim s() As String = Regex.Split("\s*,\s*", template.Tag)
			Dim BodyA As X2BodyWrapper = X2.GetBodyWrapperById(s(0))
			Dim BodyB As X2BodyWrapper = X2.GetBodyWrapperById(s(1))
			Dim position As B2Vec2 = template.BodyDef.Position
			'
			revdef.Initialize(BodyA.Body, BodyB.Body, position)
			'
			' connect the whell with the Pendulum
			If strName = "Hinge_left" Then
				HingeWheelLeft = world.CreateJoint(revdef)
			Else 

			End If
				
				
		End If
	Next
	
	Dim MotorDef As B2MotorJointDef
	MotorDef.Initialize(ground.Body, WheelLeft.Body)
	MotorDef.MaxMotorTorque = 400
	MotorDef.MaxMotorForce = 1500
	MotorDef.CollideConnected = True 'let the mouse collide with the borders
	WheelDriveMotor = world.CreateJoint(MotorDef)
	WheelDriveMotor.CorrectionFactor = 1
	
	
End Sub

Private Sub PanelForTouch_Touch (Action As Int, X As Double, Y As Double)
	X = Max(0, Min(X, PanelForTouch.Width))
	Y = Max(0, Min(Y, PanelForTouch.Height))
	Select Action
		Case PanelForTouch.TOUCH_ACTION_DOWN

			Dim p As B2Vec2 = X2.ScreenPointToWorld(X, Y)
			Dim touched As List = X2.GetBodiesIntersectingWithWorldPoint(p)
			If touched.Size > 0 Then
				MovingBody = True
				Dim bw As X2BodyWrapper = touched.Get(0)
				TouchedBody = bw.Body
				TouchedBody.GravityScale = 0
				TouchedBody.SleepingAllowed = False
				'
				' Where is the Body touched
				TouchPointVec = TouchedBody.GetLocalPoint(p)
				'
			Else
				MovingBody = False
			End If
			
		Case PanelForTouch.TOUCH_ACTION_MOVE
			Dim p As B2Vec2 = X2.ScreenPointToWorld(X, Y)
			If MovingBody Then
				TouchedBody.SetTransform(p,  TouchedBody.Angle)
			Else
				
			End If
			
		Case PanelForTouch.TOUCH_ACTION_UP
			If MovingBody = False Then
				
			Else
				TouchedBody.GravityScale = 1
				TouchedBody.SleepingAllowed = True
			End If
	End Select
End Sub

Private Sub normalizeAngle(angle As Double) As Double
	
	Do While  (angle >  180 * DegToRAD)
	 	angle = angle - 360 * DegToRAD
	Loop
		
	Do While  (angle < -180 * DegToRAD)
		angle = angle + 360 * DegToRAD
	Loop 
	Return angle
 End Sub

Public Sub Tick (GS As X2GameStep)
	'
	If GameOver Then Return
	'
	If RightDown Then
		Pendulum.Body.ApplyLinearImpulse(TankMovementForce, Pendulum.Body.Position)
	Else If LeftDown Then
		Pendulum.Body.ApplyLinearImpulse(TankMovementForce.Negate, Pendulum.Body.Position)
	End If
	'
	If q Then
		X2.AddFutureTask(Me, "game_over", 500, Null)
		GameOver = True
	End If

	posAvg =  WheelLeft.Body.WorldCenter.X 
	
	positionController.Error = targetPosition - posAvg 
	positionController.Tick( X2.TimeStepMs /1000 , intProcessTyp) ' <-- per Second
	
	Dim Value As Float = targetPosition - posAvg
	Log("ErrPos: " & Value)
	'
	Dim targetLinAccel As Double = positionController.Output
	Log("Output Accel: " & targetLinAccel)
	
	
'	targetLinAccel = b2Clamp(targetLinAccel, -10, 10 )

	Dim targetAngle As Double = targetLinAccel / world.Gravity.Y
'	targetAngle = b2Clamp(targetAngle, -10 * DegToRAD, 10 * DegToRAD)
	
	Dim currentAngle As Double = Pendulum.Body.Angle

'	currentAngle = normalizeAngle(currentAngle)
	Dim Value As Float = (targetAngle - currentAngle) * RADToDeg
	Log("ErrWinkel: " & Value)
	'
	angleController.Error = targetAngle - currentAngle

	angleController.Tick( X2.TimeStepMs/1000 , intProcessTyp) ' <-- per Second
	
	Dim targetLocation As Double = angleController.Output  
	Log("Output loc: " & targetLocation)
		
	WheelDriveMotor.LinearOffset = X2.CreateVec2( targetPosition - ground.Body.WorldCenter.X + targetLocation , 0 )
	
	mScore.Value = WheelLeft.Body.LinearVelocity.X * 3.6
	mScore.Tick
	
	
	If GS.ShouldDraw Then
		

		Dim v As B2Vec2 = WheelLeft.Body.WorldCenter
		v = ClipScreenCenterToMapArea(v.CreateCopy) ' nur eine Kopie(!) des Vektors übergeben

		X2.UpdateWorldCenter(v)
		

	End If
	
	
End Sub


Sub ClipScreenCenterToMapArea (v As B2Vec2) As B2Vec2
	Dim ScreenHalfWidth As Double = X2.ScreenAABB.Width / 2
	Dim ScreenHalfHeight As Double = X2.ScreenAABB.Height / 2
	v.X = Max(ScreenHalfWidth, Min(TileMap.MapAABB.Width - ScreenHalfWidth, v.X))
	v.Y = Max(ScreenHalfHeight, Min(TileMap.MapAABB.Height - ScreenHalfHeight, v.Y))
	' Finale Screen Koordinaten
	Return v
End Sub

Private Sub b2Clamp(number As Double, minimum As Double, maximum As Double) As Double
	'
	If number < minimum Then 
		number = minimum
	else If number > maximum Then
		number = minimum
	End If
	'
	Return number	
	'
End Sub


Public Sub Resize
	X2.ImageViewResized
End Sub

Public Sub DrawingComplete
	TileMap.DrawingComplete
End Sub

'Return True to stop the game loop
Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
	Return False
End Sub


